package de.ipk.pdwexpress.peObjGenerator;

import de.ipk.pdwexpress.tableObjects.*;
import java.util.Collection;
import java.util.HashSet;

public class PEObjectGenerator
{
  protected static String nl;
  public static synchronized PEObjectGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    PEObjectGenerator result = new PEObjectGenerator();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + NL + "package de.ipk.pdwexpress.peobjects;" + NL + "" + NL + "import java.util.Collection;" + NL + "import java.util.Iterator;" + NL + "import java.util.Vector;" + NL + "" + NL + "import de.ipk.pdwexpress.upload.AbstractPEObject;" + NL + "import de.ipk.pdwexpress.tableObjects.Term;" + NL + "import de.ipk.pdwexpress.upload.ExternDBInterface;" + NL;
  protected final String TEXT_2 = NL + "  \t" + NL + "/**" + NL + " * Generated Class" + NL + " * " + NL + " */  \t\t" + NL + "public class PE_";
  protected final String TEXT_3 = " extends AbstractPEObject {" + NL + "" + NL + "" + NL + "\t/*" + NL + "\t* ===========================================================================" + NL + "\t* Methodes for Object_attr" + NL + "\t* ===========================================================================" + NL + "\t*/" + NL + "\t" + NL + "\t/**" + NL + "\t * Get-Methode for the Object type" + NL + "\t *" + NL + "\t * @return The OJT_ID corresponds the current Object" + NL + "\t */" + NL + "\tpublic final String getObj_ojt_id() {" + NL + "\t\treturn \"";
  protected final String TEXT_4 = "\";" + NL + "\t}" + NL + "\t\t";
  protected final String TEXT_5 = "\t\t" + NL + "\t\t/**" + NL + "\t\t * @return Value for: ";
  protected final String TEXT_6 = ": ";
  protected final String TEXT_7 = " <br>" + NL + "\t\t * NULL if the value was not set.     " + NL + "\t\t */" + NL + "\t\tpublic final String get";
  protected final String TEXT_8 = "(){" + NL + "\t\t\tTerm t =getTerm(\"";
  protected final String TEXT_9 = "\");" + NL + "\t\t\treturn (t==null) ? null : t.getTrm_value();" + NL + "\t\t}\t" + NL;
  protected final String TEXT_10 = "\t" + NL + "" + NL + "\t\t\t\t/**" + NL + "\t\t\t\t * Identifer Attributes are only allowed in combination with a named Databases <br>" + NL + "\t\t\t\t * Trm_value and trm_acc will be set to the value of parameter 'acc' <br>" + NL + "\t\t\t\t *" + NL + "\t\t\t\t * @param acc Accession within Database. " + NL + "\t\t\t\t * @param edb The Database see PE_ExternDBEnum." + NL + "\t\t\t\t */" + NL + "\t\t\t\tpublic final void set";
  protected final String TEXT_11 = "(String acc, ExternDBInterface edb){" + NL + "\t\t\t\t\tsetTerm(\"";
  protected final String TEXT_12 = "\", new Term(\"";
  protected final String TEXT_13 = "\", acc, acc, edb.getEDB_Id() ));" + NL + "\t\t\t\t}\t\t" + NL + "\t\t\t\t" + NL + "\t\t\t" + NL + "\t\t\t\t/**" + NL + "\t\t\t\t * " + NL + "\t\t\t\t * @return Object which represent data of TERMS_T for catgory:";
  protected final String TEXT_14 = "<br>" + NL + "\t\t\t\t *         NULL if the value was not set." + NL + "\t\t\t\t*/" + NL + "\t\t\t\t public final Term get";
  protected final String TEXT_15 = "_Term(){" + NL + "\t\t\t\t\treturn getTerm(\"";
  protected final String TEXT_16 = "\");" + NL + "\t\t\t\t}\t\t" + NL + "\t";
  protected final String TEXT_17 = "\t\t" + NL;
  protected final String TEXT_18 = NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t     * Sets value for '";
  protected final String TEXT_19 = "' <br>" + NL + "\t\t\t\t\t */" + NL + "\t\t\t\t\tpublic final void add";
  protected final String TEXT_20 = "(String value){" + NL + "\t\t\t\t\t\taddTerm(\"";
  protected final String TEXT_21 = "\", new Term(\"";
  protected final String TEXT_22 = "\",value));" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\t" + NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t\t * " + NL + "\t\t\t\t     * @return Value for: ";
  protected final String TEXT_23 = ": ";
  protected final String TEXT_24 = " <br>" + NL + "\t\t\t\t     *         NULL if the value was not set.  " + NL + "\t\t\t\t\t */" + NL + "\t\t\t\t\tpublic final Collection<String> getALL";
  protected final String TEXT_25 = "(){" + NL + "\t\t\t\t\t\tCollection<Term> terms =getAllTerms(\"";
  protected final String TEXT_26 = "\");" + NL + "\t\t\t\t\t\t" + NL + "\t\t\t\t\t\tCollection<String> fk=null;" + NL + "\t\t\t\t\t\tif (terms != null && terms.size() != 0){" + NL + "\t\t\t\t\t\t\tfk = new Vector<String>();" + NL + "\t\t\t\t\t\t\t" + NL + "\t\t\t\t\t\t\tIterator<Term> it = terms.iterator();" + NL + "\t\t\t\t\t\t\twhile(it.hasNext())" + NL + "\t\t\t\t\t\t\tfk.add(it.next().getTrm_value());" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\treturn fk;" + NL + "\t\t\t\t\t}\t" + NL + "\t\t\t\t\t" + NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t\t * Sets value for '";
  protected final String TEXT_27 = "' <br>" + NL + "\t\t\t\t\t *" + NL + "\t\t\t\t\t * @param value ";
  protected final String TEXT_28 = NL + "\t\t\t\t\t * @param edbacc Accession within Database" + NL + "\t\t\t\t\t * @param edb The Database see PE_ExternDBEnum" + NL + "\t\t\t\t\t */\t" + NL + "\t\t\t\t\tpublic final void add";
  protected final String TEXT_29 = "(String value,String edbacc, PE_ExternDBEnum edb){" + NL + "\t\t\t\t\t\taddTerm(\"";
  protected final String TEXT_30 = "\", new Term(\"";
  protected final String TEXT_31 = "\", value, edbacc, edb.getEDB_Id() ));" + NL + "\t\t\t\t\t}\t\t\t\t\t\t\t" + NL + "\t";
  protected final String TEXT_32 = NL + "\t" + NL + "\t\t/**" + NL + "\t\t * Sets value for '";
  protected final String TEXT_33 = "' <br>" + NL + "\t\t *" + NL + "\t\t * @param value ";
  protected final String TEXT_34 = NL + "\t\t */" + NL + "\t\tpublic final void set";
  protected final String TEXT_35 = "(String value){" + NL + "\t\t\tsetTerm(\"";
  protected final String TEXT_36 = "\", new Term(\"";
  protected final String TEXT_37 = "\",value));" + NL + "\t\t}" + NL + "\t\t" + NL + "\t\t" + NL + "\t\t/**" + NL + "\t\t * Sets value for '";
  protected final String TEXT_38 = "' <br>" + NL + "\t\t *" + NL + "\t\t * @param value ";
  protected final String TEXT_39 = NL + "\t\t * @param edbacc Accession within Database" + NL + "\t\t * @param edb The Database see PE_ExternDBEnum" + NL + "\t\t */\t" + NL + "\t\tpublic final void set";
  protected final String TEXT_40 = "(String value,String edbacc, PE_ExternDBEnum edb){" + NL + "\t\t\tsetTerm(\"";
  protected final String TEXT_41 = "\", new Term(\"";
  protected final String TEXT_42 = "\", value, edbacc, edb.getEDB_Id() ));" + NL + "\t\t}\t\t" + NL + "\t";
  protected final String TEXT_43 = NL + NL + NL + NL + NL + "\t" + NL + "\t" + NL + "\t/*" + NL + "\t * ====================================================================" + NL + "\t * Getter and Setter for Foreign Key Attributes " + NL + "\t * ====================================================================" + NL + "\t */" + NL + "\t " + NL;
  protected final String TEXT_44 = NL + "\t" + NL + "\t\t\t/**" + NL + "\t\t\t *";
  protected final String TEXT_45 = "\t\t\t " + NL + "\t\t\t * @deprecated Be aware there is an alternative <code>Add</code>-methode";
  protected final String TEXT_46 = "\t\t\t " + NL + "\t\t\t * @param value The value for ForeignKey ";
  protected final String TEXT_47 = NL + "\t\t\t */" + NL + "\t\t\tpublic final void setFK_";
  protected final String TEXT_48 = "(String value){" + NL + "\t\t\t\tsetTerm(\"";
  protected final String TEXT_49 = "\", new Term(\"";
  protected final String TEXT_50 = "\",value));" + NL + "\t\t\t}" + NL + "\t" + NL + "\t" + NL + "\t\t\t/**" + NL + "\t\t\t *";
  protected final String TEXT_51 = "\t\t\t " + NL + "\t\t\t * @deprecated Be aware there is an alternative <code>getAll</code>-methode";
  protected final String TEXT_52 = "\t\t\t\t" + NL + "\t\t\t * @return The value for ForeignKey ";
  protected final String TEXT_53 = " <br>" + NL + "\t\t\t *\t\t    ";
  protected final String TEXT_54 = NL + "\t\t\t */" + NL + "\t\t\tpublic final String getFK_";
  protected final String TEXT_55 = "(){" + NL + "\t\t\t\tTerm t =getTerm(\"";
  protected final String TEXT_56 = "\");" + NL + "\t\t\t\treturn (t==null) ? null : t.getTrm_value();" + NL + "\t\t\t}\t" + NL + "\t";
  protected final String TEXT_57 = NL + "\t\t\t\t/**" + NL + "\t\t\t\t * " + NL + "\t\t\t\t * @param value The value for ForeignKey ";
  protected final String TEXT_58 = NL + "\t\t\t\t */" + NL + "\t\t\t\tpublic final void addFK_";
  protected final String TEXT_59 = "(String value){" + NL + "\t\t\t\t\taddTerm(\"";
  protected final String TEXT_60 = "\", new Term(\"";
  protected final String TEXT_61 = "\",value));" + NL + "\t\t\t\t}" + NL + "\t\t\t\t" + NL + "\t\t\t\t/**" + NL + "\t\t\t\t * " + NL + "\t\t\t\t * @return The value for ForeignKey ";
  protected final String TEXT_62 = " <br>" + NL + "\t\t\t\t *\t\t    ";
  protected final String TEXT_63 = NL + "\t\t\t\t */" + NL + "\t\t\t\tpublic final Collection<String> getALL_FK_";
  protected final String TEXT_64 = "(){" + NL + "\t\t\t\t\tCollection<Term> terms =getAllTerms(\"";
  protected final String TEXT_65 = "\");" + NL + "\t\t\t\t\t" + NL + "\t\t\t\t\tCollection<String> fk=null;" + NL + "\t\t\t\t\tif (terms != null && terms.size() != 0){" + NL + "\t\t\t\t\t\tfk = new Vector<String>();" + NL + "\t\t\t\t\t\t" + NL + "\t\t\t\t\t\tIterator<Term> it = terms.iterator();" + NL + "\t\t\t\t\t\twhile(it.hasNext())" + NL + "\t\t\t\t\t\tfk.add(it.next().getTrm_value());" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\treturn fk;" + NL + "\t\t\t\t}\t\t";
  protected final String TEXT_66 = "\t" + NL + "\t" + NL + "" + NL + "    /* " + NL + "     * =================================================================================" + NL + "     *   get/setter for Object Type Attributes" + NL + "     * =================================================================================" + NL + "     */" + NL + "   ";
  protected final String TEXT_67 = "\t\t" + NL + "\t\t\t/**" + NL + "\t\t\t * Sets value for '";
  protected final String TEXT_68 = "' <br>" + NL + "\t\t\t *";
  protected final String TEXT_69 = "\t\t\t " + NL + "\t\t\t * @deprecated Be aware there is an alternative <code>Add</code>-methode";
  protected final String TEXT_70 = "\t\t\t " + NL + "\t\t\t * @param value ";
  protected final String TEXT_71 = NL + "\t\t\t */" + NL + "\t\t\tpublic final void set";
  protected final String TEXT_72 = "(String value){" + NL + "\t\t\t\tsetTerm(\"";
  protected final String TEXT_73 = "\", new Term(\"";
  protected final String TEXT_74 = "\",value));" + NL + "\t\t\t}" + NL + "\t\t\t" + NL + "\t\t\t" + NL + "\t\t\t/**" + NL + "\t\t\t * Sets value for '";
  protected final String TEXT_75 = "' <br>";
  protected final String TEXT_76 = "\t\t\t " + NL + "\t\t\t * @deprecated Be aware there is an alternative <code>Add</code>-methode";
  protected final String TEXT_77 = "\t\t\t " + NL + "\t\t\t * @param value ";
  protected final String TEXT_78 = NL + "\t\t\t * @param edbacc Accession within Database" + NL + "\t\t\t * @param edb The Database see PE_ExternDBEnum" + NL + "\t\t\t */\t" + NL + "\t\t\tpublic final void set";
  protected final String TEXT_79 = "(String value,String edbacc, PE_ExternDBEnum edb){" + NL + "\t\t\t\tsetTerm(\"";
  protected final String TEXT_80 = "\", new Term(\"";
  protected final String TEXT_81 = "\", value, edbacc, edb.getEDB_Id() ));" + NL + "\t\t\t}\t\t" + NL + "\t\t\t" + NL + "\t\t\t" + NL + "\t\t\t/**" + NL + "\t\t\t *";
  protected final String TEXT_82 = "\t\t\t " + NL + "\t\t\t * @deprecated Be aware there is an alternative <code>getAll</code>-methode";
  protected final String TEXT_83 = "\t\t\t\t\t " + NL + "\t\t\t * @return Value for: ";
  protected final String TEXT_84 = ": ";
  protected final String TEXT_85 = " <br>" + NL + "\t\t\t *         NULL if the value was not set.     " + NL + "\t\t\t */" + NL + "\t\t\tpublic final String get";
  protected final String TEXT_86 = "(){" + NL + "\t\t\t\tTerm t =getTerm(\"";
  protected final String TEXT_87 = "\");" + NL + "\t\t\t\treturn (t==null) ? null : t.getTrm_value();" + NL + "\t\t\t}\t \t" + NL + "" + NL + "\t";
  protected final String TEXT_88 = NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t     * Sets value for '";
  protected final String TEXT_89 = "' <br>" + NL + "\t\t\t\t\t */" + NL + "\t\t\t\t\tpublic final void add";
  protected final String TEXT_90 = "(String value){" + NL + "\t\t\t\t\t\taddTerm(\"";
  protected final String TEXT_91 = "\", new Term(\"";
  protected final String TEXT_92 = "\",value));" + NL + "\t\t\t\t\t}" + NL + "\t\t\t\t\t" + NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t\t * " + NL + "\t\t\t\t     * @return Value for: ";
  protected final String TEXT_93 = ": ";
  protected final String TEXT_94 = " <br>" + NL + "\t\t\t\t     *         NULL if the value was not set.  " + NL + "\t\t\t\t\t */" + NL + "\t\t\t\t\tpublic final Collection<String> getALL";
  protected final String TEXT_95 = "(){" + NL + "\t\t\t\t\t\tCollection<Term> terms =getAllTerms(\"";
  protected final String TEXT_96 = "\");" + NL + "\t\t\t\t\t\t" + NL + "\t\t\t\t\t\tCollection<String> fk=null;" + NL + "\t\t\t\t\t\tif (terms != null && terms.size() != 0){" + NL + "\t\t\t\t\t\t\tfk = new Vector<String>();" + NL + "\t\t\t\t\t\t\t" + NL + "\t\t\t\t\t\t\tIterator<Term> it = terms.iterator();" + NL + "\t\t\t\t\t\t\twhile(it.hasNext())" + NL + "\t\t\t\t\t\t\tfk.add(it.next().getTrm_value());" + NL + "\t\t\t\t\t\t}" + NL + "\t\t\t\t\t\treturn fk;" + NL + "\t\t\t\t\t}\t" + NL + "\t\t\t\t\t" + NL + "\t\t\t\t\t/**" + NL + "\t\t\t\t\t * Sets value for '";
  protected final String TEXT_97 = "' <br>" + NL + "\t\t\t\t\t *" + NL + "\t\t\t\t\t * @param value ";
  protected final String TEXT_98 = NL + "\t\t\t\t\t * @param edbacc Accession within Database" + NL + "\t\t\t\t\t * @param edb The Database see PE_ExternDBEnum" + NL + "\t\t\t\t\t */\t" + NL + "\t\t\t\t\tpublic final void add";
  protected final String TEXT_99 = "(String value,String edbacc, PE_ExternDBEnum edb){" + NL + "\t\t\t\t\t\taddTerm(\"";
  protected final String TEXT_100 = "\", new Term(\"";
  protected final String TEXT_101 = "\", value, edbacc, edb.getEDB_Id() ));" + NL + "\t\t\t\t\t}\t\t\t\t\t\t\t" + NL + "\t";
  protected final String TEXT_102 = NL + "\t" + NL + "" + NL + "}";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
    	ObjectTypes_Categories ojtCat=(ObjectTypes_Categories)argument; 
    stringBuffer.append(TEXT_2);
    stringBuffer.append( ojtCat.getObjectType().getOjt_name() );
    stringBuffer.append(TEXT_3);
    stringBuffer.append(ojtCat.getObjectType().getOjt_ID());
    stringBuffer.append(TEXT_4);
    
	for (TRM_Category cat: ojtCat.getCategoriesCommon()){
  

    stringBuffer.append(TEXT_5);
    stringBuffer.append(cat.getTct_name().replace('\n', ' '));
    stringBuffer.append(TEXT_6);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_7);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_8);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_9);
    		   
		//Special Methodes for Identifier
		if (cat.getTct_name().endsWith("Identifier")) {

    stringBuffer.append(TEXT_10);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_11);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_12);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_13);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_14);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_15);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_16);
    
			continue;
		} // if Identifier
		
		// Methods for Name, Description

    stringBuffer.append(TEXT_17);
    
		    /* 
		     * =================================================================================
		     *   add/GetAll for Object_attr Attributes
		     * =================================================================================
		     */

			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_18);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_19);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_22);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_23);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_24);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_25);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_26);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_27);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_28);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_30);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_31);
    	
			} // if ManyToMany==1

    stringBuffer.append(TEXT_32);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_33);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_34);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_35);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_36);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_37);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_38);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_39);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_40);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_41);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_42);
    
	} // for categoriesCommon

    stringBuffer.append(TEXT_43);
     
	// Getter and Setter for Foreign Key Attributes 
	Collection <TRM_Category> categoriesFK=ojtCat.getCategoriesFK();
	for (TRM_Category cat: categoriesFK){

    stringBuffer.append(TEXT_44);
    			
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_45);
    
}

    stringBuffer.append(TEXT_46);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_47);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_48);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_49);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_50);
    			
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_51);
    
}

    stringBuffer.append(TEXT_52);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_53);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_54);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_55);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_56);
    
			/*
			 * =============================================================
			 *   add / getAll Methode for FK (if ManyToMany == 1 )
			 * =============================================================
			 */
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_57);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_58);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_59);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_60);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_61);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_62);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_63);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_64);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_65);
    
		} // if ManyToMany == 1

	} // for categoriesFK

    stringBuffer.append(TEXT_66);
     
    // Getter and Setter for object Type Attributes
    
	Collection <TRM_Category> cats=ojtCat.getCategoriesAttr();
	
	for (TRM_Category cat: ojtCat.getCategoriesAttr()){
	

    stringBuffer.append(TEXT_67);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_68);
    			
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_69);
    
}

    stringBuffer.append(TEXT_70);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_71);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_72);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_73);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_74);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_75);
    			
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_76);
    
}

    stringBuffer.append(TEXT_77);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_78);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_79);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_80);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_81);
    			
			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_82);
    
}

    stringBuffer.append(TEXT_83);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_84);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_85);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_86);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_87);
    
		    /* 
		     * =================================================================================
		     *   add/GetAll for Object Type Attributes
		     * =================================================================================
		     */

			if (cat.getTct_many().equals("1")){

    stringBuffer.append(TEXT_88);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_89);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_90);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_91);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_92);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_93);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_94);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_95);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_96);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_97);
    stringBuffer.append(cat.getTct_desc().replace('\n', ' '));
    stringBuffer.append(TEXT_98);
    stringBuffer.append(cat.getTct_name());
    stringBuffer.append(TEXT_99);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_100);
    stringBuffer.append(cat.getTct_id());
    stringBuffer.append(TEXT_101);
    	
			} // if ManyToMany==1
	} // for getCategoriesAttr

    stringBuffer.append(TEXT_102);
    return stringBuffer.toString();
  }
}
