package de.ipk.pdwexpress.tableObjects;


public class Term {

	private String trm_tct_id;
	
	private String trm_value;

	private String trm_edbacc;

	private String trm_edb_id;

	private String trm_desc;
	
	private String trm_id;
	

	public Term(String trm_tct_id, String trm_value, String trm_edbacc, String trm_edb_id, String trm_desc) {
		this.trm_value = trm_value;
		this.trm_desc = trm_desc;
		this.trm_edbacc = trm_edbacc;
		this.trm_tct_id = trm_tct_id;
		this.trm_edb_id = trm_edb_id;
	}
	
	public Term(String trm_tct_id, String trm_value, String trm_edbacc, String trm_edb_id) {
		this.trm_value = trm_value;
		this.trm_edbacc = trm_edbacc;
		this.trm_tct_id = trm_tct_id;
		this.trm_edb_id = trm_edb_id;
	}	


	/**
	 * 
	 * @param trm_tct_id
	 * @param trm_value
	 */
	public Term(String trm_tct_id, String trm_value) {
		this.trm_value = trm_value;
		this.trm_tct_id = trm_tct_id;
	}


	
	@Override
	public String toString() {
		// TODO toString
		return "trm_id:"+trm_id+" trm_value:"+trm_value+" trm_edbacc:"+trm_edbacc+" trm_edb_id:"+trm_edb_id+" trm_tct_id:"+trm_tct_id;
//	     return new ToStringBuilder(this).
//	       append("trm_id", trm_id).
//	       append("trm_value", trm_value).
//	       append("trm_desc", trm_desc).
//	       append("trm_edb_id", trm_edb_id).
//	       append("trm_edbacc", trm_edbacc).
//	       append("trm_tct_id",trm_tct_id).
//	       toString();
		
	}



	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((trm_desc == null) ? 0 : trm_desc.hashCode());
		result = PRIME * result + ((trm_edb_id == null) ? 0 : trm_edb_id.hashCode());
		result = PRIME * result + ((trm_edbacc == null) ? 0 : trm_edbacc.hashCode());
		result = PRIME * result + ((trm_tct_id == null) ? 0 : trm_tct_id.hashCode());
		result = PRIME * result + ((trm_value == null) ? 0 : trm_value.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final Term other = (Term) obj;
		if (trm_desc == null) {
			if (other.trm_desc != null)
				return false;
		} else if (!trm_desc.equals(other.trm_desc))
			return false;
		if (trm_edb_id == null) {
			if (other.trm_edb_id != null)
				return false;
		} else if (!trm_edb_id.equals(other.trm_edb_id))
			return false;
		if (trm_edbacc == null) {
			if (other.trm_edbacc != null)
				return false;
		} else if (!trm_edbacc.equals(other.trm_edbacc))
			return false;
		if (trm_tct_id == null) {
			if (other.trm_tct_id != null)
				return false;
		} else if (!trm_tct_id.equals(other.trm_tct_id))
			return false;
		if (trm_value == null) {
			if (other.trm_value != null)
				return false;
		} else if (!trm_value.equals(other.trm_value))
			return false;
		return true;
	}


	public String getTrm_desc() {
		return trm_desc;
	}

	public void setTrm_desc(String trm_desc) {
		this.trm_desc = trm_desc;
	}

	public String getTrm_edb_id() {
		return trm_edb_id;
	}

	public void setTrm_edb_id(String trm_edb_id) {
		this.trm_edb_id = trm_edb_id;
	}

	public String getTrm_edbacc() {
		return trm_edbacc;
	}

	public void setTrm_edbacc(String trm_edbacc) {
		this.trm_edbacc = trm_edbacc;
	}

	public String getTrm_id() {
		return trm_id;
	}

	public void setTrm_id(String trm_id) {
		this.trm_id = trm_id;
	}

	public String getTrm_tct_id() {
		return trm_tct_id;
	}

	public void setTrm_tct_id(String trm_tct_id) {
		this.trm_tct_id = trm_tct_id;
	}

	public String getTrm_value() {
		return trm_value;
	}

	public void setTrm_value(String trm_value) {
		this.trm_value = trm_value;
	}

	
	
}
