package de.ipk.pdwexpress.peObjGenerator;

import de.ipk.pdwexpress.tableObjects.*;
import java.util.Set;
import java.util.Iterator;

public class ExternDBsGenerator
{
  protected static String nl;
  public static synchronized ExternDBsGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    ExternDBsGenerator result = new ExternDBsGenerator();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + "package de.ipk.pdwexpress.peobjects;" + NL + "" + NL + "import de.ipk.pdwexpress.upload.ExternDBInterface;" + NL;
  protected final String TEXT_2 = NL + NL + "public enum PE_ExternDBEnum implements ExternDBInterface {" + NL + "" + NL + "\t";
  protected final String TEXT_3 = NL + "\t";
  protected final String TEXT_4 = "(\"";
  protected final String TEXT_5 = "\")\t" + NL + "\t";
  protected final String TEXT_6 = NL + "\t," + NL + "\t";
  protected final String TEXT_7 = " ;" + NL + "\t";
  protected final String TEXT_8 = NL + "\t" + NL + "\tprivate String id;" + NL + "" + NL + "\tprivate PE_ExternDBEnum(String id) {" + NL + "\t\tthis.id = id;" + NL + "\t}" + NL + "" + NL + "\t/**" + NL + "\t * " + NL + "\t * @return ID of the Database (EDB_ID from EXTERNDB_T)" + NL + "\t */" + NL + "\tpublic final String getEDB_Id() {" + NL + "\t\treturn id;" + NL + "\t}" + NL + "" + NL + "}";

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
    	Set<ExternDB> allEdb=(Set<ExternDB>)argument; 
    stringBuffer.append(TEXT_2);
      
    	Iterator<ExternDB> it = allEdb.iterator(); 
    	while (it.hasNext()) {
		  ExternDB edb = it.next();
	
    stringBuffer.append(TEXT_3);
    stringBuffer.append(edb.getEdb_name().replace(' ', '_'));
    stringBuffer.append(TEXT_4);
    stringBuffer.append(edb.getEdb_id());
    stringBuffer.append(TEXT_5);
     if (it.hasNext())
    stringBuffer.append(TEXT_6);
    else
    stringBuffer.append(TEXT_7);
    
		} 
	
    stringBuffer.append(TEXT_8);
    return stringBuffer.toString();
  }
}
