package de.ipk.pdwexpress.peObjGenerator;

import java.util.HashSet;
import java.util.Set;

import de.ipk.pdwexpress.tableObjects.Object_Type;
import de.ipk.pdwexpress.tableObjects.TRM_Category;


/**
 * Helper class for generator <br>
 * contains Object_Type - object and TRM_Category objects
 * 
 * @author Thomas
 *
 */
public class ObjectTypes_Categories  {

	private Set<TRM_Category> categoriesAttr = new HashSet<TRM_Category>();
	private Set<TRM_Category> categoriesFK = new HashSet<TRM_Category>();
	private Set<TRM_Category> categoriesCommon = new HashSet<TRM_Category>();
	
	private Object_Type objectType;
	
	public ObjectTypes_Categories(Object_Type obj,Set<TRM_Category> categories) {
		this.objectType=obj;
		this.categoriesAttr=categories;
	}
	
	public ObjectTypes_Categories(Object_Type obj) {
		this.objectType=obj;
	}


	public Object_Type getObjectType() {
		return objectType;
	}

	public Set<TRM_Category> getCategoriesAttr() {
		return categoriesAttr;
	}

	public void setCategoriesAttr(Set<TRM_Category> categoriesAttr) {
		this.categoriesAttr = categoriesAttr;
	}

	public Set<TRM_Category> getCategoriesCommon() {
		return categoriesCommon;
	}

	public void setCategoriesCommon(Set<TRM_Category> categoriesCommon) {
		this.categoriesCommon = categoriesCommon;
	}

	public Set<TRM_Category> getCategoriesFK() {
		return categoriesFK;
	}

	public void setCategoriesFK(Set<TRM_Category> categoriesFK) {
		this.categoriesFK = categoriesFK;
	}
	
	
	

}
