package de.ipk.pdwexpress.upload;

import java.sql.SQLException;

import de.ipk.pdwexpress.tableObjects.Term;

public interface PE_Object {

	public abstract String getObj_ojt_id();


	/**
	 * Checks if the dataset already exists <br>
	 * (Datasets are equals if OBJ_Identifier, TRM_EDBACC and TRM_EDB_ID 
	 * are equals) <br>
	 * <br> 
	 * Stores the data in in the database, if not exists <br>
	 * 
	 * @return OBJ_ID from table OBJECTS_T
	 * @throws SQLException
	 */
	public abstract String saveObject() throws SQLException;

	public abstract  String getObj_id();
	
	public abstract Term getOBJ_Identifier_Term();
	public abstract String getOBJ_Identifier();
	public abstract void setOBJ_Identifier(String acc, ExternDBInterface edb);
	
	public abstract String getOBJ_Name();
	
}